Time entries are broken if grouped by project and issue custom fields

2021-04-17 20:39 - Alexander Meindl

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Go MAEDA % Done: 0%

Category: Custom fields Estimated time: 0.00 hour

Target version: 4.2.1   

Resolution: Fixed Affected version: 4.2.0

Description

If you have a custom field for project, which can be used for group by filter (e.g. a list format).

If you try to use this custom fields for group by on time entries this throw an exception:

Query::StatementInvalid: Mysql2::Error: Unknown column 'cf_14.value' in 'field list': SELECT COUNT

(DISTINCT `time_entries`.`id`) AS count_

 This error occurs on project scope and without project scope.

What I found out, till now:

this is new with Redmine 4.2

with earlier Redmine versions, you cannot select a group by field from other entities implementation

I see the following solutions:

allow group by on custom fields from other entities and this error (it looks like the join to custom field is missing)

do not offer group by fields of custom fields from other entities

My test environment:

Redmine 4.2.0

Ruby 2.7.3

PostgreSQL 13

No plugin

Related issues:

Related to Redmine - Defect #33290: Unnecessary database access when IssueQue... Closed

Associated revisions

Revision 20956 - 2021-04-21 09:29 - Go MAEDA

Disable grouping for associations custom field (#35115).

Patch by Marius BALTEANU.

Revision 20957 - 2021-04-21 10:07 - Go MAEDA

Merged r20956 from trunk to 4.2-stable (#35115).

History

#1 - 2021-04-17 20:40 - Alexander Meindl

Same problem with MySQL, but the problem should the same with all database types.

#2 - 2021-04-19 08:45 - Marius BĂLTEANU

- Status changed from New to Confirmed

- Assignee set to Marius BĂLTEANU

- Target version set to 4.2.1
#3 - 2021-04-19 13:59 - xi won

- File 193333990[1].zip added

#4 - 2021-04-19 21:59 - Marius BĂLTEANU

- File deleted (193333990[1].zip)

#5 - 2021-04-19 22:02 - Marius BĂLTEANU

Before r20830, project custom fields were not groupable in associations and this is way this issue was not presented in earlier versions.

#6 - 2021-04-19 22:29 - Marius BĂLTEANU

- File 0001-Disable-grouping-for-associations-custom-field.patch added

- Assignee deleted (Marius BĂLTEANU)

For 4.2.1, we should restore the old behaviour, I've attached a fix.

Alexander, thanks for reporting this issue. Regarding allow group by on custom fields from other entities, please open a new issue for this and if you

have an working patch to implement this, I will be happy to review it for 5.0.0.

#7 - 2021-04-21 09:23 - Go MAEDA

- Related to Defect #33290: Unnecessary database access when IssueQuery class is defined added

#8 - 2021-04-21 10:07 - Go MAEDA

- Status changed from Confirmed to Closed

- Assignee set to Go MAEDA

- Resolution set to Fixed

Committed the fix. Thank you.

Files

0001-Disable-grouping-for-associations-custom-field.patch 1.19 KB 2021-04-19 Marius BĂLTEANU
